<a>
    <img src="https://images.fengoffice.com/github/header_readme.png" alt="fengoffice Docs & Notes & Wikis" />
</a>

<h1 align="center">
    <img height="70" src="https://images.fengoffice.com/github/normal_logo.svg">
</h1>
<h2 align="center" style="color: #264653;">
    ⭐️   An open source business and project management platform   ⭐️
</h2>

<p align="center">
    <a href="https://github.com/fengoffice/fengoffice"><img src="https://img.shields.io/github/stars/fengoffice/fengoffice.svg?style=flat&logo=github&colorB=deeppink&label=stars"></a>
    <a href="https://github.com/fengoffice/fengoffice"><img src="https://img.shields.io/github/forks/fengoffice/fengoffice.svg"></a>
    <a href="https://opensource.org/licenses/AGPL-3.0"><img src="https://img.shields.io/badge/license-AGPL-purple.svg" alt="License: AGPL"></a>
</p>

<p align="center">
    <a href="https://www.fengoffice.com"><b>Website</b></a> •
    <a href="https://twitter.com/fengoffice"><b>Twitter</b></a> •
    <a href="https://www.youtube.com/fengoffice"><b>Youtube</b></a>
</p>

<h2 align="left" style="color: #2A9D8F;">
    Feng Office
</h2>
<br/>

<p style="color: #264653; padding:0 40px;">
Feng Office is a business management platform that provides powerful and flexible tracking, management, and automation tools for running businesses, projects, and services, both large and small.
</p>

<p style="color: #264653; padding:0 40px;">
All its modules are seamlessly connected and integrated through an easy-to-use interface, making organizing and browsing all your information a very intuitive task.
</p>

<p style="color: #264653; padding:0 40px;">
We are constantly adding new and more powerful automation features, improving its ease of use and performance, and integrating with external tools to support your business operations, delivering lots of value to our clients and our community.
</p>

<p style="color: #264653; padding:0 40px;">
Feng Office is a Collaboration Platform and Project Management System.
It is licensed under the Affero GPL 3 license.
</p>

<h2 align="left" style="color: #2A9D8F;">
    Screenshots
</h2>
<br/>

<p align="center"><img src="https://images.fengoffice.com/github/capture_one.png" alt="fengoffice Docs & Notes & Wikis" width="1000px" /></p>
<br/>

<p align="center"><img src="https://images.fengoffice.com/github/capture_two.png" alt="fengoffice Databases for Tasks and Projects" width="1000px" /></p>
<br/>

<p align="center"><img src="https://images.fengoffice.com/github/capture_three.png" alt="fengoffice Kanban Board for To-Dos" width="1000px" /></p>
<br/>

<p align="center"><img src="https://images.fengoffice.com/github/capture_four.png" alt="fengoffice Calendars for Plan and Manage Content" width="1000px" /></p>
<br/>

<p align="center"><img src="https://images.fengoffice.com/github/capture_five.png" alt="fengoffice Calendars for Plan and Manage Content" width="1000px" /></p>
<br/>

<!-- ## System requerements -->
<h2 align="left" style="color: #2A9D8F;">
    System requirements
</h2>

<p style="color: #264653; padding:0 20px;">
Feng Office requires a running Web Server, PHP (5.0 or greater) and MySQL (InnoDB
 support recommended). The recommended Web Server is Apache.
</p>

<!-- ## Languages and tools -->
<h2 align="left" style="color: #2A9D8F;">
    Languages ​​and tools
</h2>

<p style="display: inline-block;" align="center">
  <kbd>
    <kbd>Front-end</kbd>
    <br>
    <br>
    <img width="60px" src="https://cdn.jsdelivr.net/gh/devicons/devicon/icons/html5/html5-original.svg" />
    <img width="60px" src="https://cdn.jsdelivr.net/gh/devicons/devicon/icons/css3/css3-plain.svg" />
    <img width="60px" src="https://cdn.jsdelivr.net/gh/devicons/devicon/icons/javascript/javascript-original.svg" />
    <img width="60px" src="https://cdn.jsdelivr.net/gh/devicons/devicon/icons/jquery/jquery-original-wordmark.svg" />
  </kbd>
  <kbd>
    <kbd>Back-end</kbd>
    <br>
    <br>
    <img width="60px" src="https://cdn.jsdelivr.net/gh/devicons/devicon/icons/php/php-original.svg" />
    <img width="60px" src="https://cdn.jsdelivr.net/gh/devicons/devicon/icons/laravel/laravel-plain.svg"" />
  </kbd>
  <kbd>
    <kbd>Databases</kbd>
    <br>
    <br>
    <img width="60px" src="https://cdn.jsdelivr.net/gh/devicons/devicon/icons/mysql/mysql-original-wordmark.svg"" />
  </kbd>
  <br>
  <kbd>
    <kbd>Infrastructure</kbd>
    <br>
    <br>
    <img width="60px" src="https://cdn.jsdelivr.net/gh/devicons/devicon/icons/apache/apache-original-wordmark.svg" />
    <img width="60px" src="https://cdn.jsdelivr.net/gh/devicons/devicon/icons/docker/docker-original-wordmark.svg"" />
  </kbd>
  <kbd>
    <kbd>Terminal Scripts</kbd>
    <br>
    <br>
    <img width="60px" src="https://cdn.jsdelivr.net/gh/devicons/devicon/icons/python/python-plain.svg" />
    <img width="60px" src="https://cdn.jsdelivr.net/gh/devicons/devicon/icons/bash/bash-original.svg" />
    <!-- <img width="60px" src="https://cdn.jsdelivr.net/gh/devicons/devicon/icons/ruby/ruby-original.svg" /> -->
  </kbd>
  <kbd>
    <kbd>Tools</kbd>
    <br>
    <br>
    <img width="60px" src="https://cdn.jsdelivr.net/gh/devicons/devicon/icons/vscode/vscode-original.svg" />
    <img width="60px" src="https://github.com/termux/termux-app/raw/master/app/src/main/res/mipmap-xxxhdpi/ic_launcher.png" />
    <img width="60px" src="https://cdn.jsdelivr.net/gh/devicons/devicon/icons/grafana/grafana-original.svg">
  </kbd>
</p>

<!-- ## Recomendations -->
<h2 align="left" style="color: #2A9D8F;">
    Recommendations
</h2>

<p style="color: #264653; padding:0 20px;">
PHP 7.1+
</p>

<p style="color: #264653; padding:0 20px;">
MySQL 5+ with InnoDB support
</p>

<p style="color: #264653; padding:0 20px;">
Apache 2.0+
</p>

<ul style="padding:0 40px;">
    <li style="color: #264653;">PHP <a href="http://www.php.net/">http://www.php.net/</a></li>
    <li style="color: #264653;">MySQL <a href="http://www.mysql.com/">http://www.mysql.com/</a></li>
    <li style="color: #264653;">Apache <a href="http://www.apache.org/">http://www.apache.org/</a></li>
</ul>

<p style="color: #264653; padding:0 20px;">
 Please have a look at our requirements here:
</p>

<a style="padding:0 20px;" href="https://wiki.fengoffice.com/doku.php/installation:server_reqs">https://wiki.fengoffice.com/doku.php/installation:server_reqs</a>

<p style="color: #264653; padding:0 20px;">
 Alternatively, if you just want to test Feng Office and you don't care about security
 issues with your files, you can download XAMPP, which includes all that is needed
 by Feng Office (Apache, PHP 7, MySQL) in a single download.
 You can configure MySQL to support InnoDB by commenting or removing
 the line 'skip-innodb' in the file '<INSTALL_DIR>/etc/my.cnf'.
</p>

<ul>
    <li style="color: #264653;padding:0 20px;">XAMPP <a href="https://www.apachefriends.org/">https://www.apachefriends.org/</a></li>
</ul>

<!-- ## Installation -->
<h2 align="left" style="color: #2A9D8F;">
    Installation
</h2>

<ol>
    <li style="color: #264653;">Download Feng Office - <a href="http://www.fengoffice.com/web/community/downloads.php">http://www.fengoffice.com/web/community/downloads.php</a></li>
    <li style="color: #264653;">Unpack and upload to your web server</li>
    <li style="color: #264653;">Direct your browser to the public/install directory and follow the installation procedure</li>
    <p style="color: #264653;">
    Further information can be found here: <a href="https://wiki.fengoffice.com/doku.php/installation:installation">https://wiki.fengoffice.com/doku.php/installation:installation</a>
    </p>
    <p style="color: #264653;">
    You should be finished in a matter of minutes.
    </p>
    <li style="color: #264653;">Some functionality may require further configuration, like setting up a cron job.
    Check the wiki for more information: <a href="https://wiki.fengoffice.com/doku.php/setup">https://wiki.fengoffice.com/doku.php/setup</a></li>
    <p style="color: #264653;">
    WARNING: Default memory limit por PHP is 8MB. As a new Feng Office install consumes about 10 MB,
    administrators could get a message similar to "Allowed memory size of 8388608 bytes exhausted".
    This can be solved by setting "memory_limit=32" in php.ini.
    </p>
</ol>

<!-- ## Upgrade -->
<h2 align="left" style="color: #2A9D8F;">
    Upgrade
</h2>

<p style="color: #264653;padding:0 20px;">
 You should be finished in a matter of minutes.
</p>

<ol style="padding:0 40px;">
    <li style="color: #264653;">From 3.X to 3.X (or from 2.X to 2.X, or 1.X to 1.X)</li>
    <li style="color: #264653;">From 1.X to 2.X</li>
</ol>

<p style="color: #264653; padding:0 20px;">
  Either way, we strongly suggest reading the following article in our Wiki for further information:
 <a href="https://wiki.fengoffice.com/doku.php/installation:migration">https://wiki.fengoffice.com/doku.php/installation:migration</a>
</p>

<p style="color: #264653; padding:0 20px;">
 Note: Plugins must also be updated (if it corresponds)
</p>

<!-- ## Open Source -->
<h2 align="left" style="color: #2A9D8F;">
    Open Source Libraries
</h2>

<p style="color: #264653;padding:0 20px;">
 The following open source libraries and applications have been adapted to work with Feng Office:
</p>

<ul>
    <li style="color: #264653;padding:0 20px;">ActiveCollab 0.7.1 - <a href="http://www.activecollab.com">http://www.activecollab.com</a></li>
    <li style="color: #264653;padding:0 20px;">ExtJs - <a href="http://www.extjs.com">http://www.extjs.com</a></li>
    <li style="color: #264653;padding:0 20px;">jQuery - <a href="http://www.jquery.com">http://www.jquery.com</a></li>
    <li style="color: #264653;padding:0 20px;">jQuery tools - <a href="http://flowplayer.org/tools/">http://flowplayer.org/tools/</a></li>
    <li style="color: #264653;padding:0 20px;">jQuery Collapsible - <a href="http://phpepe.com/2011/07/jquery-collapsible-plugin.html">http://phpepe.com/2011/07/jquery-collapsible-plugin.html</a></li>
    <li style="color: #264653;padding:0 20px;">jQuery Scroll To - <a href="http://flesler.blogspot.com/2007/10/jqueryscrollto.html">http://flesler.blogspot.com/2007/10/jqueryscrollto.html</a></li>
    <li style="color: #264653;padding:0 20px;">jQuery ModCoder - <a href="http://modcoder.com/">http://modcoder.com/</a></li>
    <li style="color: #264653;padding:0 20px;">jQuery User Interface - <a href="http://jqueryui.com/">http://jqueryui.com/</a></li>
    <li style="color: #264653;padding:0 20px;">jQuery ImgAreaSelect plugin - <a href="http://odyniec.net/projects/imgareaselect/">http://odyniec.net/projects/imgareaselect/</a></li>
    <li style="color: #264653;padding:0 20px;">jQuery SimpleModal plugin - <a href="http://www.ericmmartin.com/projects/simplemodal/">http://www.ericmmartin.com/projects/simplemodal/</a></li>
    <li style="color: #264653;padding:0 20px;">H5F (HTML 5 Forms) - <a href="http://thecssninja.com/javascript/H5F">http://thecssninja.com/javascript/H5F</a></li>
    <li style="color: #264653;padding:0 20px;"><a href="http://flowplayer.org/tools/">http://flowplayer.org/tools/</a></li>
    <li style="color: #264653;padding:0 20px;">Reece Calendar - <a href="http://sourceforge.net/projects/reececalendar">http://sourceforge.net/projects/reececalendar</a></li>
    <li style="color: #264653;padding:0 20px;">Swift Mailer - <a href="http://www.swiftmailer.org">http://www.swiftmailer.org</a></li>
    <li style="color: #264653;padding:0 20px;">Open Flash Chart - <a href="http://teethgrinder.co.uk/open-flash-chart">http://teethgrinder.co.uk/open-flash-chart</a></li>
    <li style="color: #264653;padding:0 20px;">PHPExcel - <a href="https://github.com/PHPOffice/PHPExcel">https://github.com/PHPOffice/PHPExcel</a></li>
    <li style="color: #264653;padding:0 20px;">Slimey - <a href="http://slimey.sourceforge.net">http://slimey.sourceforge.net</a></li>
    <li style="color: #264653;padding:0 20px;">FCKEditor - <a href="http://www.fckeditor.net">http://www.fckeditor.net</a></li>
    <li style="color: #264653;padding:0 20px;">JSSoundKit - <a href="http://jssoundkit.sourceforge.net">http://jssoundkit.sourceforge.net</a></li>
    <li style="color: #264653;padding:0 20px;">PEAR - <a href="http://pear.php.net">http://pear.php.net</a></li>
    <li style="color: #264653;padding:0 20px;">Gelsheet - <a href="http://www.gelsheet.org">http://www.gelsheet.org</a></li>
    <li style="color: #264653;padding:0 20px;">TimeZoneDB - <a href="https://timezonedb.com">https://timezonedb.com</a></li>

</ul>
